﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace DropBack
{
    /// <summary>
    /// Interaction logic for DropableTextBlock.xaml
    /// </summary>
    public partial class DropableTextBlock : UserControl
    {
        public DropableTextBlock()
        {
            InitializeComponent();
        }

        public string InnerText
        {
            get { return GetValue(TextProperty).ToString(); }
            set { SetValue(TextProperty, value); }
        }

        public string DropChannel
        {
            get { return GetValue(DropChannelProperty).ToString(); }
            set { SetValue(DropChannelProperty, value); }
        }

        public static readonly DependencyProperty DropChannelProperty = DependencyProperty.Register("DropChannel", typeof(string), typeof(DropableTextBlock), new FrameworkPropertyMetadata(string.Empty));

        public static readonly DependencyProperty TextProperty = DependencyProperty.Register("InnerText", typeof(string), typeof(DropableTextBlock), new FrameworkPropertyMetadata(string.Empty, TextChangedCallback));

        private static void TextChangedCallback(DependencyObject d, DependencyPropertyChangedEventArgs e)
        {
            var control = d as DropableTextBlock;
            control.textBlock.Text = (string)e.NewValue;
        }

        private void textDragSource_Drop(object sender, Infragistics.DragDrop.DropEventArgs e)
        {
            TextBlock dragSource = (e.DragSource as TextBlock);
            if (dragSource != null)
            {
                TextBlock dropText = (e.DropTarget as TextBlock);
                if (dropText != null)
                {
                    // Drop to Text
                    //dropText.Text = dragSource.Text;

                    DropableTextBlock dropParent = (dragSource.Parent as DropableTextBlock);

                    if (dropParent != null)
                    {
                        dropParent.InnerText = dragSource.Text;
                    }
                }
                DropableTextBlock dragParent = (dragSource.Parent as DropableTextBlock);

                if (dragParent != null)
                {
                    dragParent.InnerText = string.Empty;
                }
            }
        }
    }
}
